# Contributing

### Contributor

Thanks for taking you time to contribute to this repo. Before you start contributing please go through the following guidelines which we consider are important to maintain this repository and can help new contributers to open source.

- Before you submit a pull request ensure a issue exists, describing the issue / feature request. If it doesn't please file an issue so that we could discuss about the issue before the actual PR is submitted.

- The issue description should be sufficient enough to explain the bug/feature request and a possible solution / proposal.

- We appreciate any contributions, from fixing a grammar mistake in the docs, improving code snippets to fixing a bug or making a feature requests and writing proper tests are also highly welcome.

- Follow the [dart best practices](https://dart.dev/guides/language/effective-dart) to maintain the quality of code.

- Additional changes for publishing a release. Update the version in readme, pubspec.yaml, and update the changelog

Contributing

1. Fork This repo.
2. Create a new branch.
3. Commit a fix.
4. Add appropriate tests(recommended).
5. Submit a PR referencing the issue.
6. Request a review.
7. wait for LGTM 🚀 comment.

### Publishing (Applicable for the maintainer of the repository)

When publishing a new release of this package make sure all the below points are done.

- Update the version in readme, pubspec.yaml, and update the changelog.
- make sure the documentation is updated as per the changes.
- make sure existing and new tests are passing.
- make sure the code is well formatted.
- ensure the linter warnings are zero.
